// $Id: admin.js,v 1.9 2007/07/26 23:25:11 merlinofchaos Exp $

Drupal.UserTitles = {};

Drupal.UserTitles.autoAttach = function() {
  // ensure add button does not submit even if failure
  $("input#edit-add-submit").click(function() {
    return false;
  });

  // Bind our buttons.
  $("input#edit-add-submit").click(Drupal.UserTitles.addTitle);
  $("table#user-titles-settings img.title-delete").click(Drupal.UserTitles.removeTitle);
}

Drupal.UserTitles.addTitle = function() {
  // Collect our values.
  var title = $('input#edit-add-title').val();
  var value = parseInt($('input#edit-add-value').val(), 10);
  if (isNaN(value)) {
    value = 0;
  }

  // Reset our input boxes to blank
  $('input#edit-add-value').val('');
  $('input#edit-add-title').val('');

  // Count existing rows to determine what the new stripe should be
  var num = $('table#user-titles-settings tbody tr:not(:hidden)').size() + 1;

  // Get the total number of titles, counting deleted ones, so we can give this
  // the right number.
  var real_num = parseInt($('input#edit-num-titles').val());

  // Build the new title
  var html = '<tr class="' + (num % 2 ? 'odd' : 'even') + '">';
  html += '<td class="num-posts"><input type="text" name="titles[' + real_num + '][value]" size="2" value="' + value + '"></td>';
  html += '<td class="user-title"><input type="text" name="titles[' + real_num + '][title]" size="30" value="' + title + '"></td>';
  html += '<td><img src="' + Drupal.settings.userTitles.imageURL + '" alt="Remove this title" title="Remove this title" class="title-delete" /></td>';
  html += '</tr>';

  // Add our new title.
  $('table#user-titles-settings tbody').append(html);

  // Update the number of actual titles we have.
  $('input#edit-num-titles').val(real_num + 1)

  // Rebind delete click icons so the new icon will still be able to delete.
  // It's easier to unbind the existing ones than to try to find the one
  // we just added because we're not using ids per row.
  $("table#user-titles-settings img.title-delete")
    .unclick()
    .click(Drupal.UserTitles.removeTitle);
  
  // Change focus for easier input.
  $('input#edit-add-value').get(0).focus();
  return false;
}

Drupal.UserTitles.removeTitle = function() {
  $(this).parent().parent()
    .hide()
    .find('input').val('');

  // When we delete an item, we have to restripe the table otherwise
  // we'll have two evens (or two odds) next to each other.

  // Thanks to Bdragon and dmitrig01 for this bit of code.
  // :even and :odd are reversed because jquery counts from 0 and
  // we count from 1, so we're out of sync.
  $('table#user-titles-settings tbody tr:not(:hidden)')
    .removeClass('even')
    .removeClass('odd')
    .filter(':even')
      .addClass('odd')
    .end()
    .filter(':odd')
      .addClass('even');
}

// We are ignoring the global Drupal killswitch, because this module doesn't
// currently degrade gracefully. It can, but the code has not yet been written.

// if (Drupal.jsEnabled) {
  $(Drupal.UserTitles.autoAttach);
// }
